diff --git a/django/conf/locale/he/LC_MESSAGES/django.mo b/django/conf/locale/he/LC_MESSAGES/django.mo
index e471f5b..e0a81d6 100644
Binary files a/django/conf/locale/he/LC_MESSAGES/django.mo and b/django/conf/locale/he/LC_MESSAGES/django.mo differ
diff --git a/django/conf/locale/he/LC_MESSAGES/django.po b/django/conf/locale/he/LC_MESSAGES/django.po
index 5cf96f9..fbd41c5 100644
--- a/django/conf/locale/he/LC_MESSAGES/django.po
+++ b/django/conf/locale/he/LC_MESSAGES/django.po
@@ -5,8 +5,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Django\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2009-04-22 09:54-0500\n"
-"PO-Revision-Date: 2009-04-22 10:54-0500\n"
+"POT-Creation-Date: 2009-04-30 15:43-0500\n"
+"PO-Revision-Date: 2009-04-30 16:33-0500\n"
 "Last-Translator: Alex <alex.gaynor@gmail.com>\n"
 "Language-Team: Django-i18n <django-i18n@googlegroups.com>\n"
 "MIME-Version: 1.0\n"
@@ -224,7 +224,7 @@ msgstr "סינית מסורתית"
 msgid "Successfully deleted %(count)d %(items)s."
 msgstr "%(count)d %(items)s  היו נמחקו בהצלחה."
 
-#: contrib/admin/actions.py:63 contrib/admin/options.py:1023
+#: contrib/admin/actions.py:63 contrib/admin/options.py:1025
 msgid "Are you sure?"
 msgstr "האם את/ה בטוח/ה ?"
 
@@ -267,15 +267,15 @@ msgstr "החודש"
 msgid "This year"
 msgstr "השנה"
 
-#: contrib/admin/filterspecs.py:147 forms/widgets.py:413
+#: contrib/admin/filterspecs.py:147 forms/widgets.py:434
 msgid "Yes"
 msgstr "כן"
 
-#: contrib/admin/filterspecs.py:147 forms/widgets.py:413
+#: contrib/admin/filterspecs.py:147 forms/widgets.py:434
 msgid "No"
 msgstr "לא"
 
-#: contrib/admin/filterspecs.py:154 forms/widgets.py:413
+#: contrib/admin/filterspecs.py:154 forms/widgets.py:434
 msgid "Unknown"
 msgstr "לא ידוע"
 
@@ -315,93 +315,93 @@ msgstr "רישומי יומן"
 msgid "None"
 msgstr "ללא"
 
-#: contrib/admin/options.py:517
+#: contrib/admin/options.py:519
 #, python-format
 msgid "Changed %s."
 msgstr "%s שונה."
 
-#: contrib/admin/options.py:517 contrib/admin/options.py:527
-#: contrib/comments/templates/comments/preview.html:16 forms/models.py:306
+#: contrib/admin/options.py:519 contrib/admin/options.py:529
+#: contrib/comments/templates/comments/preview.html:16 forms/models.py:384
 msgid "and"
 msgstr "ו"
 
-#: contrib/admin/options.py:522
+#: contrib/admin/options.py:524
 #, python-format
 msgid "Added %(name)s \"%(object)s\"."
 msgstr "התווסף %(name)s \"%(object)s\"."
 
-#: contrib/admin/options.py:526
+#: contrib/admin/options.py:528
 #, python-format
 msgid "Changed %(list)s for %(name)s \"%(object)s\"."
 msgstr "שונה %(list)s עבור %(name)s \"%(object)s\"."
 
-#: contrib/admin/options.py:531
+#: contrib/admin/options.py:533
 #, python-format
 msgid "Deleted %(name)s \"%(object)s\"."
 msgstr "נמחק %(name)s \"%(object)s\"."
 
-#: contrib/admin/options.py:535
+#: contrib/admin/options.py:537
 msgid "No fields changed."
 msgstr "אף שדה לא השתנה."
 
-#: contrib/admin/options.py:596 contrib/auth/admin.py:67
+#: contrib/admin/options.py:598 contrib/auth/admin.py:67
 #, python-format
 msgid "The %(name)s \"%(obj)s\" was added successfully."
 msgstr "הוספת %(name)s \"%(obj)s\" בוצעה בהצלחה."
 
-#: contrib/admin/options.py:600 contrib/admin/options.py:633
+#: contrib/admin/options.py:602 contrib/admin/options.py:635
 #: contrib/auth/admin.py:75
 msgid "You may edit it again below."
 msgstr "ניתן לערוך שוב מתחת"
 
-#: contrib/admin/options.py:610 contrib/admin/options.py:643
+#: contrib/admin/options.py:612 contrib/admin/options.py:645
 #, python-format
 msgid "You may add another %s below."
 msgstr "ניתן להוסיף %s נוסף מתחת."
 
-#: contrib/admin/options.py:631
+#: contrib/admin/options.py:633
 #, python-format
 msgid "The %(name)s \"%(obj)s\" was changed successfully."
 msgstr "שינוי %(name)s \"%(obj)s\" בוצע בהצלחה."
 
-#: contrib/admin/options.py:639
+#: contrib/admin/options.py:641
 #, python-format
 msgid ""
 "The %(name)s \"%(obj)s\" was added successfully. You may edit it again below."
 msgstr "הוספת %(name)s \"%(obj)s\" בוצעה בהצלחה. ניתן לערוך אותו שוב מתחת."
 
-#: contrib/admin/options.py:770
+#: contrib/admin/options.py:772
 #, python-format
 msgid "Add %s"
 msgstr "הוספת %s"
 
-#: contrib/admin/options.py:801 contrib/admin/options.py:1001
+#: contrib/admin/options.py:803 contrib/admin/options.py:1003
 #, python-format
 msgid "%(name)s object with primary key %(key)r does not exist."
 msgstr "הפריט %(name)s עם המקש %(key)r אינו קיים."
 
-#: contrib/admin/options.py:858
+#: contrib/admin/options.py:860
 #, python-format
 msgid "Change %s"
 msgstr "שינוי %s"
 
-#: contrib/admin/options.py:902
+#: contrib/admin/options.py:904
 msgid "Database error"
 msgstr "שגיאת בסיס נתונים"
 
-#: contrib/admin/options.py:938
+#: contrib/admin/options.py:940
 #, python-format
 msgid "%(count)s %(name)s was changed successfully."
 msgid_plural "%(count)s %(name)s were changed successfully."
 msgstr[0] "שינוי %(count)s %(name)s בהצלחה."
 msgstr[1] "שינוי %(count)s %(name)s בהצלחה."
 
-#: contrib/admin/options.py:1016
+#: contrib/admin/options.py:1018
 #, python-format
 msgid "The %(name)s \"%(obj)s\" was deleted successfully."
 msgstr "מחיקת %(name)s \"%(obj)s\" בוצעה בהצלחה."
 
-#: contrib/admin/options.py:1052
+#: contrib/admin/options.py:1054
 #, python-format
 msgid "Change history: %s"
 msgstr "היסטוריית שינוי: %s"
@@ -1741,18 +1741,24 @@ msgid ""
 msgstr ""
 "לצערנו פג תוקף הטופס שלך.  עליך להמשיך למלא את הטופס מן העמוד הזה ואילך."
 
-#: contrib/gis/forms/fields.py:14
+#: contrib/gis/forms/fields.py:17
 msgid "No geometry value provided."
 msgstr "לא סופק ערך גיאומטרי."
 
-#: contrib/gis/forms/fields.py:15
+#: contrib/gis/forms/fields.py:18
 msgid "Invalid geometry value."
 msgstr "ערך גאומטרי שגוי."
 
-#: contrib/gis/forms/fields.py:16
+#: contrib/gis/forms/fields.py:19
 msgid "Invalid geometry type."
 msgstr "סוג גיאומטרי שגוי."
 
+#: contrib/gis/forms/fields.py:20
+msgid ""
+"An error occurred when transforming the geometry to the SRID of the geometry "
+"form field."
+msgstr "הייתה בעיה עם השינוי של הצורה לסוג של השדה."
+
 #: contrib/humanize/templatetags/humanize.py:19
 msgid "th"
 msgstr "רביעי"
@@ -3964,7 +3970,7 @@ msgstr "ה-URL הזה נראה כקישור שבור."
 msgid "Select a valid choice. %(value)s is not one of the available choices."
 msgstr "יש לבחור אפשרות חוקית. %(value)s אינו בין האפשרויות הזמינות."
 
-#: forms/fields.py:703 forms/fields.py:764 forms/models.py:780
+#: forms/fields.py:703 forms/fields.py:764 forms/models.py:863
 msgid "Enter a list of values."
 msgstr "יש להזין רשימת ערכים"
 
@@ -3981,25 +3987,30 @@ msgstr "יש להזין ערך המכיל אותיות, ספרות, קווים 
 msgid "Order"
 msgstr "מיון"
 
-#: forms/models.py:299 forms/models.py:308
+#: forms/models.py:363
+#, python-format
+msgid "%(field_name)s must be unique for %(date_field)s %(lookup)s."
+msgstr "%(field_name)s חייב להיות ייחודי ל%(lookup)s של ה%(date_field)s"
+
+#: forms/models.py:377 forms/models.py:385
 #, python-format
 msgid "%(model_name)s with this %(field_label)s already exists."
 msgstr "%(model_name)s·עם·%(field_label)s·זה קיימת כבר."
 
-#: forms/models.py:655
+#: forms/models.py:738
 msgid "The inline foreign key did not match the parent instance primary key."
 msgstr "הרצופות מפתח זר לא תאם את האב מופע המפתח העיקרי."
 
-#: forms/models.py:710
+#: forms/models.py:793
 msgid "Select a valid choice. That choice is not one of the available choices."
 msgstr "יש לבחור אפשרות חוקית; '%(data)s' אינו בין %(choices)s."
 
-#: forms/models.py:781
+#: forms/models.py:864
 #, python-format
 msgid "Select a valid choice. %s is not one of the available choices."
 msgstr "יש לבחור אפשרות חוקית. %s אינו בין האפשרויות הזמינות."
 
-#: forms/models.py:783
+#: forms/models.py:866
 #, python-format
 msgid "\"%s\" is not a valid value for a primary key."
 msgstr "\"%s\" איננו חוקי כמקש עיקרי."
@@ -4318,393 +4329,3 @@ msgstr "ה-%(verbose_name)s עודכן בהצלחה."
 #, python-format
 msgid "The %(verbose_name)s was deleted."
 msgstr "ה-%(verbose_name)s נמחק."
-
-#~ msgid "DATE_WITH_TIME_FULL"
-#~ msgstr "l d.m.y H:i:s"
-
-#~ msgid "headline"
-#~ msgstr "כותרת"
-
-#~ msgid "rating #1"
-#~ msgstr "דירוג #1"
-
-#~ msgid "rating #2"
-#~ msgstr "דירוג #2"
-
-#~ msgid "rating #3"
-#~ msgstr "דירוג #3"
-
-#~ msgid "rating #4"
-#~ msgstr "דירוג #4"
-
-#~ msgid "rating #5"
-#~ msgstr "דירוג #5"
-
-#~ msgid "rating #6"
-#~ msgstr "דירוג #6"
-
-#~ msgid "rating #7"
-#~ msgstr "דירוג #7"
-
-#~ msgid "rating #8"
-#~ msgstr "דירוג #8"
-
-#~ msgid "is valid rating"
-#~ msgstr "האם דירוג חוקי"
-
-#~ msgid "Content object"
-#~ msgstr "אובייקט תוכן"
-
-#~ msgid "person's name"
-#~ msgstr "שם"
-
-#~ msgid "ip address"
-#~ msgstr "כתובת IP"
-
-#~ msgid "approved by staff"
-#~ msgstr "אושר ע\"י הצוות"
-
-#~ msgid "free comments"
-#~ msgstr "הערות אנונימיות"
-
-#~ msgid "score"
-#~ msgstr "ציון"
-
-#~ msgid "score date"
-#~ msgstr "תאריך ציון"
-
-#~ msgid "karma score"
-#~ msgstr "ניקוד קארמה"
-
-#~ msgid "karma scores"
-#~ msgstr "ניקודי קארמה"
-
-#~ msgid "%(score)d rating by %(user)s"
-#~ msgstr "%(score)d·דירוג ע\"י·%(user)s"
-
-#~ msgid ""
-#~ "This comment was flagged by %(user)s:\n"
-#~ "\n"
-#~ "%(text)s"
-#~ msgstr ""
-#~ "התגובה סומנה ע\"י %(user)s:\n"
-#~ "\n"
-#~ "%(text)s"
-
-#~ msgid "flag date"
-#~ msgstr "תאריך סימון"
-
-#~ msgid "user flag"
-#~ msgstr "סימון ע\"י משתמש"
-
-#~ msgid "user flags"
-#~ msgstr "סימונים ע\"י משתמש"
-
-#~ msgid "Flag by %r"
-#~ msgstr "סימון ע\"י %r"
-
-#~ msgid "deletion date"
-#~ msgstr "תאריך מחיקה"
-
-#~ msgid "moderator deletion"
-#~ msgstr "מחיקת מודרטור"
-
-#~ msgid "moderator deletions"
-#~ msgstr "מחיקות מודרטור"
-
-#~ msgid "Moderator deletion by %r"
-#~ msgstr "מחיקת מודרציה ע\"י %r"
-
-#~ msgid "Forgotten your password?"
-#~ msgstr "שכחת את סיסמתך?"
-
-#~ msgid "Ratings"
-#~ msgstr "דירוג"
-
-#~ msgid "Required"
-#~ msgstr "נדרש"
-
-#~ msgid "Optional"
-#~ msgstr "אופציונלי"
-
-#~ msgid "Post a photo"
-#~ msgstr "שליחת תמונה"
-
-#~ msgid "Your name:"
-#~ msgstr "שמך:"
-
-#~ msgid ""
-#~ "This rating is required because you've entered at least one other rating."
-#~ msgstr "הדירוג נדרש מאחר והזנת לפחות דרוג אחד אחר."
-
-#~ msgid ""
-#~ "This comment was posted by a user who has posted fewer than %(count)s "
-#~ "comment:\n"
-#~ "\n"
-#~ "%(text)s"
-#~ msgid_plural ""
-#~ "This comment was posted by a user who has posted fewer than %(count)s "
-#~ "comments:\n"
-#~ "\n"
-#~ "%(text)s"
-#~ msgstr[0] ""
-#~ "ההודעה נשלחה ע\"י משתמש ששלח פחות מ-%(count)s תגובה:\n"
-#~ "\n"
-#~ "%(text)s"
-#~ msgstr[1] ""
-#~ "ההודעה נשלחה ע\"י משתמש ששלח פחות מ-%(count)s תגובות:\n"
-#~ "\n"
-#~ "%(text)s"
-
-#~ msgid "Only POSTs are allowed"
-#~ msgstr "רק פעולות POST מותרות"
-
-#~ msgid "One or more of the required fields wasn't submitted"
-#~ msgstr "אחד או יותר מהשדות הנדרשים אינו נשלח."
-
-#~ msgid "Somebody tampered with the comment form (security violation)"
-#~ msgstr "מישהו התעסק עם טופס התגובה (הפרת אבטחה)"
-
-#~ msgid ""
-#~ "The comment form had an invalid 'target' parameter -- the object ID was "
-#~ "invalid"
-#~ msgstr "טופס התגובה הכיל פרמטר target לא חוקי -- מזהה האובייקט אינו חוקי"
-
-#~ msgid "The comment form didn't provide either 'preview' or 'post'"
-#~ msgstr "טופס התגובה לא הכיל 'preview' או 'post'"
-
-#~ msgid "Anonymous users cannot vote"
-#~ msgstr "משתמשים אנונימיים אינם יכולים להצביע"
-
-#~ msgid "Invalid comment ID"
-#~ msgstr "מזהה תגובה שגוי"
-
-#~ msgid "No voting for yourself"
-#~ msgstr "לא ניתן להצביע לעצמך"
-
-#~ msgid "Uppercase letters are not allowed here."
-#~ msgstr "אסור להשתמש באותיות גדולות."
-
-#~ msgid "Lowercase letters are not allowed here."
-#~ msgstr "אסור להשתמש באותיות קטנות."
-
-#~ msgid "Enter valid e-mail addresses separated by commas."
-#~ msgstr "יש להזין רק כתובות דוא\"ל מופרדות בפסיקים."
-
-#~ msgid "Please enter a valid IP address."
-#~ msgstr "נא להזין כתובת IP חוקית."
-
-#~ msgid "Empty values are not allowed here."
-#~ msgstr "חובה להזין ערך בשדה זה."
-
-#~ msgid "Non-numeric characters aren't allowed here."
-#~ msgstr "מותר להזין ספרות בלבד."
-
-#~ msgid "This value can't be comprised solely of digits."
-#~ msgstr "ערך זה אינו יכול להכיל ספרות בלבד."
-
-#~ msgid "Only alphabetical characters are allowed here."
-#~ msgstr "יש להזין כאן אותיות בלבד."
-
-#~ msgid "Enter a valid time in HH:MM format."
-#~ msgstr "יש להזין שעה במבנה HH:MM."
-
-#~ msgid "Enter a valid date/time in YYYY-MM-DD HH:MM format."
-#~ msgstr "יש להזין תאריך ושעה במבנה YYYY-MM-DD HH:MM."
-
-#~ msgid "The URL %s does not point to a valid image."
-#~ msgstr "ה-URL %s אנו מצביע לתמונה חוקית."
-
-#~ msgid "Phone numbers must be in XXX-XXX-XXXX format. \"%s\" is invalid."
-#~ msgstr "מספרי טלפון חייבים להיות במבנה XXX-XXX-XXXX.‏ \"%s\" אינו חוקי."
-
-#~ msgid "The URL %s does not point to a valid QuickTime video."
-#~ msgstr "ה-URL‏ %s אינו מצביע לסרטון QuickTime חוקי."
-
-#~ msgid "A valid URL is required."
-#~ msgstr "יש להזין URL חוקי."
-
-#~ msgid ""
-#~ "Valid HTML is required. Specific errors are:\n"
-#~ "%s"
-#~ msgstr ""
-#~ "יש להזין HTML חוקי. שגיאות ספציפיות:\n"
-#~ "%s"
-
-#~ msgid "Badly formed XML: %s"
-#~ msgstr "מבנה XML שגוי: %s"
-
-#~ msgid "Invalid URL: %s"
-#~ msgstr "URL שגוי: %s"
-
-#~ msgid "The URL %s is a broken link."
-#~ msgstr "ה-URL‏ %s הוא קישור שבור."
-
-#~ msgid "Enter a valid U.S. state abbreviation."
-#~ msgstr "יש להזין קיצור חוקי למדינה בארה\"ב."
-
-#~ msgid "This field must match the '%s' field."
-#~ msgstr "תוכן השדה חייב להיות זהה לשדה '%s'."
-
-#~ msgid "Please enter something for at least one field."
-#~ msgstr "יש להזין תוכן בלפחות אחד מהשדות."
-
-#~ msgid "Please enter both fields or leave them both empty."
-#~ msgstr "יש להזין תוכן בשני השדות או להשאיר את שניהם ריקים."
-
-#~ msgid "This field must be given if %(field)s is %(value)s"
-#~ msgstr "יש להזין תוכן בשדה זה אם שדה %(field)s מכיל %(value)s"
-
-#~ msgid "This field must be given if %(field)s is not %(value)s"
-#~ msgstr "יש להזין תוכן בשדה זה אם תוכן שדה %(field)s אינו %(value)s"
-
-#~ msgid "Duplicate values are not allowed."
-#~ msgstr "לא ניתן להזין ערכים כפולים."
-
-#~ msgid "This value must be between %(lower)s and %(upper)s."
-#~ msgstr "ערך זה חייב להיות בין %(lower)s ל-%(upper)s."
-
-#~ msgid "This value must be no more than %s."
-#~ msgstr "ערך זה אינו יכול להיות יותר מ-%s."
-
-#~ msgid "This value must be a power of %s."
-#~ msgstr "ערך זה חייב להיות חזקה של %s."
-
-#~ msgid "Please enter a valid decimal number."
-#~ msgstr "יש להזין מספר עשרוני חוקי."
-
-#~ msgid "Please enter a valid decimal number with at most %s total digit."
-#~ msgid_plural ""
-#~ "Please enter a valid decimal number with at most %s total digits."
-#~ msgstr[0] "יש להזין מספר עשרוני חוקי עם ספרה %s לכל היותר."
-#~ msgstr[1] "יש להזין מספר עשרוני חוקי עם %s ספרות לכל היותר."
-
-#~ msgid ""
-#~ "Please enter a valid decimal number with a whole part of at most %s digit."
-#~ msgid_plural ""
-#~ "Please enter a valid decimal number with a whole part of at most %s "
-#~ "digits."
-#~ msgstr[0] "יש להזין מספר עשרוני חוקי עם ספרה %s בחלק השלם לכל היותר."
-#~ msgstr[1] "יש להזין מספר עשרוני חוקי עם %s ספרות בחלק השלם לכל היותר."
-
-#~ msgid "Please enter a valid decimal number with at most %s decimal place."
-#~ msgid_plural ""
-#~ "Please enter a valid decimal number with at most %s decimal places."
-#~ msgstr[0] "יש להזין מספר עשרוני חוקי עם ספרה %s בחלק העשרוני לכל היותר."
-#~ msgstr[1] "יש להזין מספר עשרוני חוקי עם %s ספרות בחלק העשרוני לכל היותר."
-
-#~ msgid "Please enter a valid floating point number."
-#~ msgstr "נא להזין מספר נקודה צפה חוקי."
-
-#~ msgid "Make sure your uploaded file is at least %s bytes big."
-#~ msgstr "יש להעלות קובץ בגודל %s בתים לפחות."
-
-#~ msgid "Make sure your uploaded file is at most %s bytes big."
-#~ msgstr "יש לוודא שהקובץ שהעלת הוא בגודל %s בתים לכל היותר."
-
-#~ msgid "The format for this field is wrong."
-#~ msgstr "מבנה תוכן שדה זה שגוי."
-
-#~ msgid "This field is invalid."
-#~ msgstr "שדה זה אינו חוקי."
-
-#~ msgid "Could not retrieve anything from %s."
-#~ msgstr "לא ניתן לאחזר כלום מ %s."
-
-#~ msgid ""
-#~ "The URL %(url)s returned the invalid Content-Type header '%(contenttype)"
-#~ "s'."
-#~ msgstr "ה-URL·%(url)s·החזיר כותרת·Content-Type·לא חוקית·'%(contenttype)s'."
-
-#~ msgid ""
-#~ "Please close the unclosed %(tag)s tag from line %(line)s. (Line starts "
-#~ "with \"%(start)s\".)"
-#~ msgstr ""
-#~ "נא לסגור את תג·%(tag)s·בשורה·%(line)s.·(השורה מתחילה ב·\"%(start)s\".)"
-
-#~ msgid ""
-#~ "Some text starting on line %(line)s is not allowed in that context. (Line "
-#~ "starts with \"%(start)s\".)"
-#~ msgstr ""
-#~ "חלק מהטקסט בשורה·%(line)s·אסור בהקשר זה.·(השורה·מתחילה ב·\"%(start)s\".)"
-
-#~ msgid ""
-#~ "\"%(attr)s\" on line %(line)s is an invalid attribute. (Line starts with "
-#~ "\"%(start)s\".)"
-#~ msgstr ""
-#~ "\"%(attr)s\"·בשורה·%(line)s·אינה תכונה חוקית.·(השורה מתחילה ב·\"%(start)s"
-#~ "\".)"
-
-#~ msgid ""
-#~ "\"<%(tag)s>\" on line %(line)s is an invalid tag. (Line starts with \"%"
-#~ "(start)s\".)"
-#~ msgstr ""
-#~ "\"<%(tag)s>\"·בשורה·%(line)s·אינו תג חוקי.·(השורה מתחילה ב·\"%(start)s\".)"
-
-#~ msgid ""
-#~ "A tag on line %(line)s is missing one or more required attributes. (Line "
-#~ "starts with \"%(start)s\".)"
-#~ msgstr ""
-#~ "לתג בשורה %(line)s חסרה תכונה אחת או יותר נדרשות. (השורה מתחילה ב-\"%"
-#~ "(start)s\".)"
-
-#~ msgid ""
-#~ "The \"%(attr)s\" attribute on line %(line)s has an invalid value. (Line "
-#~ "starts with \"%(start)s\".)"
-#~ msgstr ""
-#~ "לתכונה·\"%(attr)s\"·בשורה·%(line)s·יש ערך לא חוקי.·(השורה·מתחילה ב·\"%"
-#~ "(start)s\".)"
-
-#~ msgid ""
-#~ "%(object)s with this %(type)s already exists for the given %(field)s."
-#~ msgstr "%(object)s עם %(type)s קיים כבר עבור %(field)s נתון."
-
-#~ msgid "Enter a valid filename."
-#~ msgstr "יש להזין שם קובץ חוקי."
-
-#~ msgid "Please enter a valid %s."
-#~ msgstr "יש להזין %s חוקי."
-
-#~ msgid "Ensure your text is less than %s character."
-#~ msgid_plural "Ensure your text is less than %s characters."
-#~ msgstr[0] "נא לוודא שהטקסט שלך מכיל פחות מ %s תו."
-#~ msgstr[1] "נא לוודא שהטקסט שלך מכיל פחות מ %s תווים."
-
-#~ msgid "Line breaks are not allowed here."
-#~ msgstr "מעברי שורה אסורים כאן."
-
-#~ msgid "Select a valid choice; '%(data)s' is not in %(choices)s."
-#~ msgstr "יש לבחור אפשרות חוקית; '%(data)s' אינו בין %(choices)s."
-
-#~ msgid "Enter a whole number between -32,768 and 32,767."
-#~ msgstr "יש להזין מספר שלם בין ‎-32,768 ל- 32,767."
-
-#~ msgid "Enter a positive number."
-#~ msgstr "יש להזין מספר חיובי."
-
-#~ msgid "Enter a whole number between 0 and 32,767."
-#~ msgstr "יש להזין מספר שלם בין 0 ל- 32,767."
-
-#~ msgid "Ordering"
-#~ msgstr "מיון"
-
-#~ msgid "Your new password is: %(new_password)s"
-#~ msgstr "סיסמתך החדשה: %(new_password)s"
-
-#~ msgid "Feel free to change this password by going to this page:"
-#~ msgstr "ניתן לשנות את הסיסמה בכל עת ע\"י פניה לדף זה:"
-
-#~ msgid "Added %s."
-#~ msgstr "%s התווסף."
-
-#~ msgid "Deleted %s."
-#~ msgstr "%s נמחק."
-
-#~ msgid "The two 'new password' fields didn't match."
-#~ msgstr "שני שדות 'הסיסמה החדשה' אינם זהים."
-
-#~ msgid "Year must be 1900 or later."
-#~ msgstr "שנה צריכה להיות 1900 ומעלה."
-
-#~ msgid "Separate multiple IDs with commas."
-#~ msgstr "יש להפריד מזהים מרובים בפסיקים."