From db896a620e227628b90014dcd1b7220fc98ce6db Mon Sep 17 00:00:00 2001
From: Derek Willis <dwillis@gmail.com>
Date: Sat, 18 Sep 2010 23:15:36 -0400
Subject: [PATCH] Replaced absolute URL with absolute path reference in docs

---
 docs/faq/usage.txt               |    4 ++--
 docs/intro/tutorial03.txt        |    3 ++-
 docs/ref/contrib/sitemaps.txt    |   14 +++++++-------
 docs/ref/contrib/syndication.txt |    6 +++---
 docs/ref/models/fields.txt       |    2 +-
 docs/ref/models/instances.txt    |    6 +++---
 docs/ref/request-response.txt    |    4 ++--
 docs/ref/templates/builtins.txt  |    7 ++++---
 docs/topics/auth.txt             |    8 ++++----
 9 files changed, 28 insertions(+), 26 deletions(-)

diff --git a/docs/faq/usage.txt b/docs/faq/usage.txt
index 856b97c..5c4cd5f 100644
--- a/docs/faq/usage.txt
+++ b/docs/faq/usage.txt
@@ -63,8 +63,8 @@ Using a :class:`~django.db.models.FileField` or an
        (relative to :setting:`MEDIA_ROOT`). You'll most likely want to use the
        convenience :attr:`~django.core.files.File.url` attribute provided by
        Django. For example, if your :class:`~django.db.models.ImageField` is
-       called ``mug_shot``, you can get the absolute URL to your image in a
-       template with ``{{ object.mug_shot.url }}``.
+       called ``mug_shot``, you can get the absolute path reference to your 
+       image in a template with ``{{ object.mug_shot.url }}``.
 
 How do I make a variable available to all my templates?
 -------------------------------------------------------
diff --git a/docs/intro/tutorial03.txt b/docs/intro/tutorial03.txt
index d347035..3599af4 100644
--- a/docs/intro/tutorial03.txt
+++ b/docs/intro/tutorial03.txt
@@ -514,7 +514,8 @@ decoupling is to make it easy to plug-and-play URLs. Now that polls are in their
 own URLconf, they can be placed under "/polls/", or under "/fun_polls/", or
 under "/content/polls/", or any other URL root, and the app will still work.
 
-All the poll app cares about is its relative URLs, not its absolute URLs.
+All the poll app cares about is its relative URLs, not its absolute path 
+references.
 
 When you're comfortable with writing views, read :doc:`part 4 of this tutorial
 </intro/tutorial04>` to learn about simple form processing and generic views.
diff --git a/docs/ref/contrib/sitemaps.txt b/docs/ref/contrib/sitemaps.txt
index 7a66cbe..46acb3f 100644
--- a/docs/ref/contrib/sitemaps.txt
+++ b/docs/ref/contrib/sitemaps.txt
@@ -143,14 +143,14 @@ Sitemap class reference
 
         **Optional.** Either a method or attribute.
 
-        If it's a method, it should return the absolute URL for a given object as
-        returned by :attr:`~Sitemap.items()`.
+        If it's a method, it should return the absolute path reference for a 
+        given object as returned by :attr:`~Sitemap.items()`.
 
-        If it's an attribute, its value should be a string representing an absolute URL
-        to use for *every* object returned by :attr:`~Sitemap.items()`.
+        If it's an attribute, its value should be a string representing an absolute 
+        path reference to use for *every* object returned by :attr:`~Sitemap.items()`.
 
-        In both cases, "absolute URL" means a URL that doesn't include the protocol or
-        domain. Examples:
+        In both cases, "absolute path reference" means a URL that doesn't 
+        include the protocol or domain. Examples:
 
             * Good: :file:`'/foo/bar/'`
             * Bad: :file:`'example.com/foo/bar/'`
@@ -300,7 +300,7 @@ that: :func:`django.contrib.sitemaps.ping_google()`.
 .. function:: ping_google
 
     :func:`ping_google` takes an optional argument, :data:`sitemap_url`,
-    which should be the absolute URL of your site's sitemap (e.g.,
+    which should be the absolute path reference of your site's sitemap (e.g.,
     :file:`'/sitemap.xml'`). If this argument isn't provided,
     :func:`ping_google` will attempt to figure out your
     sitemap by performing a reverse looking in your URLconf.
diff --git a/docs/ref/contrib/syndication.txt b/docs/ref/contrib/syndication.txt
index a12d646..acd8ef2 100644
--- a/docs/ref/contrib/syndication.txt
+++ b/docs/ref/contrib/syndication.txt
@@ -274,9 +274,9 @@ comes directly from your :setting:`LANGUAGE_CODE` setting.
 URLs
 ----
 
-The :attr:`link` method/attribute can return either an absolute URL (e.g.
-:file:`"/blog/"`) or a URL with the fully-qualified domain and protocol (e.g.
-``"http://www.example.com/blog/"``). If :attr:`link` doesn't return the domain,
+The :attr:`link` method/attribute can return either an absolute path reference 
+(e.g. :file:`"/blog/"`) or a URL with the fully-qualified domain and protocol 
+(e.g. ``"http://www.example.com/blog/"``). If :attr:`link` doesn't return the domain,
 the syndication framework will insert the domain of the current site, according
 to your :setting:`SITE_ID setting <SITE_ID>`.
 
diff --git a/docs/ref/models/fields.txt b/docs/ref/models/fields.txt
index 68208b3..4a5c98c 100644
--- a/docs/ref/models/fields.txt
+++ b/docs/ref/models/fields.txt
@@ -537,7 +537,7 @@ takes a few steps:
        (relative to :setting:`MEDIA_ROOT`). You'll most likely want to use the
        convenience :attr:`~django.core.files.File.url` function provided by
        Django. For example, if your :class:`ImageField` is called ``mug_shot``,
-       you can get the absolute URL to your image in a template with
+       you can get the absolute path reference to your image in a template with
        ``{{ object.mug_shot.url }}``.
 
 For example, say your :setting:`MEDIA_ROOT` is set to ``'/home/media'``, and
diff --git a/docs/ref/models/instances.txt b/docs/ref/models/instances.txt
index dfe4c74..251d89b 100644
--- a/docs/ref/models/instances.txt
+++ b/docs/ref/models/instances.txt
@@ -491,9 +491,9 @@ Similarly, if you had a URLconf entry that looked like::
 Notice that we specify an empty sequence for the second parameter in this case,
 because we only want to pass keyword parameters, not positional ones.
 
-In this way, you're tying the model's absolute URL to the view that is used
-to display it, without repeating the URL information anywhere. You can still
-use the ``get_absolute_url`` method in templates, as before.
+In this way, you're tying the model's absolute path reference to the view 
+that is used to display it, without repeating the URL information anywhere. 
+You can still use the ``get_absolute_url`` method in templates, as before.
 
 In some cases, such as the use of generic views or the re-use of
 custom views for multiple models, specifying the view function may
diff --git a/docs/ref/request-response.txt b/docs/ref/request-response.txt
index b8b0882..2eb3075 100644
--- a/docs/ref/request-response.txt
+++ b/docs/ref/request-response.txt
@@ -579,8 +579,8 @@ types of HTTP responses. Like ``HttpResponse``, these subclasses live in
 
     The constructor takes a single argument -- the path to redirect to. This
     can be a fully qualified URL (e.g. ``'http://www.yahoo.com/search/'``) or an
-    absolute URL with no domain (e.g. ``'/search/'``). Note that this returns
-    an HTTP status code 302.
+    absolute path reference with no domain (e.g. ``'/search/'``). Note that 
+    this returns an HTTP status code 302.
 
 .. class:: HttpResponsePermanentRedirect
 
diff --git a/docs/ref/templates/builtins.txt b/docs/ref/templates/builtins.txt
index 85c0b6d..876480d 100644
--- a/docs/ref/templates/builtins.txt
+++ b/docs/ref/templates/builtins.txt
@@ -915,9 +915,10 @@ The argument tells which template bit to output:
 url
 ~~~
 
-Returns an absolute URL (i.e., a URL without the domain name) matching a given
-view function and optional parameters. This is a way to output links without
-violating the DRY principle by having to hard-code URLs in your templates::
+Returns an absolute path reference (a URL without the domain name) 
+matching a given view function and optional parameters. This is a way to 
+output links without violating the DRY principle by having to hard-code 
+URLs in your templates::
 
     {% url path.to.some_view v1 v2 %}
 
diff --git a/docs/topics/auth.txt b/docs/topics/auth.txt
index 8c9b0f1..955bde6 100644
--- a/docs/topics/auth.txt
+++ b/docs/topics/auth.txt
@@ -728,10 +728,10 @@ The login_required decorator
 
         * If the user isn't logged in, redirect to
           :setting:`settings.LOGIN_URL <LOGIN_URL>` (``/accounts/login/`` by
-          default), passing the current absolute URL in the query string. The
-          name of the GET argument is determined by the ``redirect_field_name``
-          argument provided to the decorator. The default argument name is
-          ``next``. For example:
+          default), passing the current absolute path reference in the query 
+          string. The name of the GET argument is determined by the 
+          ``redirect_field_name`` argument provided to the decorator. The 
+          default argument name is ``next``. For example:
           ``/accounts/login/?next=/polls/3/``.
 
         * If the user is logged in, execute the view normally. The view code is
-- 
1.6.5.7