Index: django/contrib/localflavor/us/models.py
===================================================================
--- django/contrib/localflavor/us/models.py	(revision 11821)
+++ django/contrib/localflavor/us/models.py	(working copy)
@@ -1,21 +1,12 @@
 from django.conf import settings
-from django.db.models.fields import Field
+from django.db.models.fields import Field, CharField
+from django.contrib.localflavor.us.us_states import STATE_CHOICES
 
-class USStateField(Field): 
-    def get_internal_type(self): 
-        return "USStateField" 
-        
-    def db_type(self):
-        if settings.DATABASE_ENGINE == 'oracle':
-            return 'CHAR(2)'
-        else:
-            return 'varchar(2)'
-    
-    def formfield(self, **kwargs): 
-        from django.contrib.localflavor.us.forms import USStateSelect 
-        defaults = {'widget': USStateSelect} 
-        defaults.update(kwargs) 
-        return super(USStateField, self).formfield(**defaults)
+class USStateField(CharField):
+    def __init__(self, *args, **kwargs):
+        kwargs['choices'] = STATE_CHOICES
+        kwargs['max_length'] = 2
+        super(USStateField, self).__init__(*args, **kwargs)
 
 class PhoneNumberField(Field):
     def get_internal_type(self):
Index: tests/regressiontests/localflavor/__init__.py
===================================================================
Index: tests/regressiontests/localflavor/tests.py
===================================================================
--- tests/regressiontests/localflavor/tests.py	(revision 0)
+++ tests/regressiontests/localflavor/tests.py	(revision 0)
@@ -0,0 +1,83 @@
+from django.test import TestCase
+from models import Place
+from forms import PlaceForm
+
+class USLocalflavorTests(TestCase):
+    def setUp(self):
+        self.form = PlaceForm({'state':'GA', 'state_req':'NC', 'name':'impossible'})
+        
+    def test_get_display_methods(self):
+        """Test that the get_*_display() methods are added to the model instances."""
+        place = self.form.save()
+        self.assertEqual(place.get_state_display(), 'Georgia')
+        self.assertEqual(place.get_state_req_display(), 'North Carolina')
+    
+    def test_required(self):
+        """Test that required USStateFields throw appropriate errors."""
+        form = PlaceForm({'state':'GA', 'name':'Place in GA'})
+        self.assertFalse(form.is_valid())
+        self.assertEqual(form.errors['state_req'], [u'This field is required.'])
+    
+    def test_field_blank_option(self):
+        """Test that the empty option is there."""
+        state_select_html = """\
+<select name="state" id="id_state">
+<option value="">---------</option>
+<option value="AL">Alabama</option>
+<option value="AK">Alaska</option>
+<option value="AS">American Samoa</option>
+<option value="AZ">Arizona</option>
+<option value="AR">Arkansas</option>
+<option value="CA">California</option>
+<option value="CO">Colorado</option>
+<option value="CT">Connecticut</option>
+<option value="DE">Delaware</option>
+<option value="DC">District of Columbia</option>
+<option value="FL">Florida</option>
+<option value="GA" selected="selected">Georgia</option>
+<option value="GU">Guam</option>
+<option value="HI">Hawaii</option>
+<option value="ID">Idaho</option>
+<option value="IL">Illinois</option>
+<option value="IN">Indiana</option>
+<option value="IA">Iowa</option>
+<option value="KS">Kansas</option>
+<option value="KY">Kentucky</option>
+<option value="LA">Louisiana</option>
+<option value="ME">Maine</option>
+<option value="MD">Maryland</option>
+<option value="MA">Massachusetts</option>
+<option value="MI">Michigan</option>
+<option value="MN">Minnesota</option>
+<option value="MS">Mississippi</option>
+<option value="MO">Missouri</option>
+<option value="MT">Montana</option>
+<option value="NE">Nebraska</option>
+<option value="NV">Nevada</option>
+<option value="NH">New Hampshire</option>
+<option value="NJ">New Jersey</option>
+<option value="NM">New Mexico</option>
+<option value="NY">New York</option>
+<option value="NC">North Carolina</option>
+<option value="ND">North Dakota</option>
+<option value="MP">Northern Mariana Islands</option>
+<option value="OH">Ohio</option>
+<option value="OK">Oklahoma</option>
+<option value="OR">Oregon</option>
+<option value="PA">Pennsylvania</option>
+<option value="PR">Puerto Rico</option>
+<option value="RI">Rhode Island</option>
+<option value="SC">South Carolina</option>
+<option value="SD">South Dakota</option>
+<option value="TN">Tennessee</option>
+<option value="TX">Texas</option>
+<option value="UT">Utah</option>
+<option value="VT">Vermont</option>
+<option value="VI">Virgin Islands</option>
+<option value="VA">Virginia</option>
+<option value="WA">Washington</option>
+<option value="WV">West Virginia</option>
+<option value="WI">Wisconsin</option>
+<option value="WY">Wyoming</option>
+</select>"""
+        self.assertEqual(str(self.form['state']), state_select_html)
Index: tests/regressiontests/localflavor/models.py
===================================================================
--- tests/regressiontests/localflavor/models.py	(revision 0)
+++ tests/regressiontests/localflavor/models.py	(revision 0)
@@ -0,0 +1,8 @@
+from django.db import models
+from django.contrib.localflavor.us.models import USStateField
+
+class Place(models.Model):
+    state = USStateField(blank=True)
+    state_req = USStateField()
+    state_default = USStateField(default="CA", blank=True)
+    name = models.CharField(max_length=20)
Index: tests/regressiontests/localflavor/forms.py
===================================================================
--- tests/regressiontests/localflavor/forms.py	(revision 0)
+++ tests/regressiontests/localflavor/forms.py	(revision 0)
@@ -0,0 +1,7 @@
+from django.forms import ModelForm
+from models import Place
+
+class PlaceForm(ModelForm):
+    """docstring for PlaceForm"""
+    class Meta:
+        model = Place
Index: AUTHORS
===================================================================
--- AUTHORS	(revision 11821)
+++ AUTHORS	(working copy)
@@ -300,6 +300,7 @@
     Jason McBrayer <http://www.carcosa.net/jason/>
     Kevin McConnell <kevin.mcconnell@gmail.com>
     mccutchen@gmail.com
+    Paul McLanahan <paul@mclanahan.net>
     Tobias McNulty <http://www.caktusgroup.com/blog>
     Christian Metts
     michael.mcewan@gmail.com