Index: django/contrib/admin/templates/admin/change_list.html
===================================================================
--- django/contrib/admin/templates/admin/change_list.html	(revision 10673)
+++ django/contrib/admin/templates/admin/change_list.html	(working copy)
@@ -2,7 +2,6 @@
 {% load adminmedia admin_list i18n %}
 
 {% block extrastyle %}
-  {{ block.super }}
   <link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/changelists.css" />
   {% if cl.formset %}
     <link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />
@@ -14,6 +13,7 @@
       #changelist table thead th:first-child {width: inherit}
     </style>
   {% endif %}
+  {{ block.super }}
 {% endblock %}
 
 {% block bodyclass %}change-list{% endblock %}
Index: django/contrib/admin/templates/admin/auth/user/change_password.html
===================================================================
--- django/contrib/admin/templates/admin/auth/user/change_password.html	(revision 10673)
+++ django/contrib/admin/templates/admin/auth/user/change_password.html	(working copy)
@@ -1,9 +1,10 @@
 {% extends "admin/base_site.html" %}
 {% load i18n admin_modify adminmedia %}
-{% block extrahead %}{{ block.super }}
+{% block extrahead %}
 <script type="text/javascript" src="../../../../jsi18n/"></script>
+{{ block.super }}
 {% endblock %}
-{% block extrastyle %}{{ block.super }}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />{% endblock %}
+{% block extrastyle %}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />{{ block.super }}{% endblock %}
 {% block bodyclass %}{{ opts.app_label }}-{{ opts.object_name.lower }} change-form{% endblock %}
 {% block breadcrumbs %}{% if not is_popup %}
 <div class="breadcrumbs">
Index: django/contrib/admin/templates/admin/index.html
===================================================================
--- django/contrib/admin/templates/admin/index.html	(revision 10673)
+++ django/contrib/admin/templates/admin/index.html	(working copy)
@@ -1,7 +1,7 @@
 {% extends "admin/base_site.html" %}
 {% load i18n %}
 
-{% block extrastyle %}{{ block.super }}<link rel="stylesheet" type="text/css" href="{% load adminmedia %}{% admin_media_prefix %}css/dashboard.css" />{% endblock %}
+{% block extrastyle %}<link rel="stylesheet" type="text/css" href="{% load adminmedia %}{% admin_media_prefix %}css/dashboard.css" />{{ block.super }}{% endblock %}
 
 {% block coltype %}colMS{% endblock %}
 
Index: django/contrib/admin/templates/admin/change_form.html
===================================================================
--- django/contrib/admin/templates/admin/change_form.html	(revision 10673)
+++ django/contrib/admin/templates/admin/change_form.html	(working copy)
@@ -1,12 +1,13 @@
 {% extends "admin/base_site.html" %}
 {% load i18n admin_modify adminmedia %}
 
-{% block extrahead %}{{ block.super }}
+{% block extrahead %}
 <script type="text/javascript" src="../../../jsi18n/"></script>
 {{ media }}
+{{ block.super }}
 {% endblock %}
 
-{% block extrastyle %}{{ block.super }}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />{% endblock %}
+{% block extrastyle %}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/forms.css" />{{ block.super }}{% endblock %}
 
 {% block coltype %}{% if ordered_objects %}colMS{% else %}colM{% endif %}{% endblock %}
 
Index: django/contrib/admin/templates/admin/login.html
===================================================================
--- django/contrib/admin/templates/admin/login.html	(revision 10673)
+++ django/contrib/admin/templates/admin/login.html	(working copy)
@@ -1,7 +1,7 @@
 {% extends "admin/base_site.html" %}
 {% load i18n %}
 
-{% block extrastyle %}{% load adminmedia %}{{ block.super }}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/login.css" />{% endblock %}
+{% block extrastyle %}{% load adminmedia %}<link rel="stylesheet" type="text/css" href="{% admin_media_prefix %}css/login.css" />{{ block.super }}{% endblock %}
 
 {% block bodyclass %}login{% endblock %}
 